function bmsc54
% In this exercise we numerically compute the distribution of the last
% visit time of a BM in point 0.
tic
%% parameter input
% horizon
T=1;
% sample size
N=10^4;
% grid points
M=10^4;

% Simulate BM with normal increments
BM = [zeros(1,N);sqrt(T/M)*cumsum(randn(M,N))];
% the process X
timegrid= 0:T/M:T;
% initialize the last visiting time
lasttime = zeros(1,N);

% rounding precision
precision= 10^2;
% round the BM
BMround= round(BM*precision)/precision;

for i=1:N
    % if BM hits zero
    if sum(BMround(:,i)==0)>0
        ind= BMround(:,i)==0;
        % last time BM visits zero
        lasttime(i)= max(timegrid(ind));
    end
end
% theoretical distribution function
theof = @(x) 2/pi*asin(sqrt(x));
% empirical distribution function
[F,X] = ecdf(lasttime);
plot(X,F,'r-',X,theof(X),'b-');
title('ArcSin law of BM: distribution function of L');
xlabel('time');
ylabel('probabilities');
legend('empirical','theoretical');
toc